/* 
 * Copyright (C) 2008 Laird Breyer
 *  
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * Author:   Laird Breyer <laird@lbreyer.com>
 */

#ifndef BOXWRITER_H
#define BOXWRITER_H

#include "common.h"
#include "imagebuffer.h"
#include "boxlist.h"
#include <zlib.h>

typedef struct {
  FILE *f;
} boxwriter_t;

bool_t create_boxwriter(boxwriter_t *p, int fd);
bool_t free_boxwriter(boxwriter_t *p);

bool_t write_boxwriter(boxwriter_t *p, box_t *b);

#endif
