/* 
 * Copyright (C) 2008 Laird Breyer
 *  
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * Author:   Laird Breyer <laird@lbreyer.com>
 */

#ifndef PBMREADER_H
#define PBMREADER_H

#include "common.h"
#include "imagebuffer.h"
#include <zlib.h>

typedef struct {
  gzFile *f;
  byte_t *buf;
  byte_t *bufpos;
  byte_t *bufend;
  size_t bufsize;
  imagetype_t type;
  imagesize_t width;
  imagesize_t height;
} pbmreader_t;

bool_t create_pbmreader(pbmreader_t *p, int fd);
bool_t reset_pbmreader(pbmreader_t *p);
bool_t free_pbmreader(pbmreader_t *p);

bool_t read_first_buffer_pbmreader(pbmreader_t *p);
bool_t read_next_buffer_pbmreader(pbmreader_t *p);

bool_t get_header_info_pbmreader(pbmreader_t *p);
bool_t read_integer_pbmreader(pbmreader_t *p, unsigned int *retval);

bool_t fillimage_pixl0_pbmreader(pbmreader_t *p, imagebuffer_t *ib);

#endif
